# List all people custom fields

GET https://api.letsdeel.com/rest/v2/people/custom_fields

Fetch all custom fields associated with People records, offering additional personalized information.
 **Token scopes**: `people:read`

Reference: https://developer.deel.com/api/endpoints/custom-fields-people/get-custom-fields

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /people/custom_fields:
    get:
      operationId: get-custom-fields
      summary: List all people custom fields
      description: >-
        Fetch all custom fields associated with People records, offering
        additional personalized information.
         **Token scopes**: `people:read`
      tags:
        - subpackage_customFieldsPeople
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/custom-fields-people_getCustomFields_Response_200
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ListAllPeopleCustomFieldsRequestInternalServerError
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name:
      type: string
      enum:
        - text
        - number
        - date
        - percentage
      description: Simple types
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name
          description: Simple types
      required:
        - name
      title: PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name:
      type: string
      enum:
        - currency
      description: Currency type
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name
          description: Currency type
        currency:
          type:
            - string
            - 'null'
          description: Currency code
        is_fixed:
          type: boolean
          description: When currency is fixed, only the amount can be edited by the users
      required:
        - name
        - is_fixed
      title: PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name:
      type: string
      enum:
        - list
        - multiselect
      description: List types
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name
          description: List types
        options:
          type: array
          items:
            type: string
          description: List of options for the custom field
      required:
        - name
        - options
      title: PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType:
      oneOf:
        - $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0
        - $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1
        - $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2
      description: Type of the custom field
      title: PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy:
      type: string
      enum:
        - organization
        - worker
      description: Entity providing access to the custom field
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess:
      type: object
      properties:
        provided_by:
          oneOf:
            - $ref: >-
                #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy
            - type: 'null'
          description: Entity providing access to the custom field
        is_sensitive:
          type: boolean
          description: Whether the custom field is sensitive
        group_permission_set:
          type:
            - string
            - 'null'
          description: Permission set identifier for the custom field
      required:
        - is_sensitive
      description: Access settings for the custom field
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems:
      type: string
      enum:
        - eor
        - contractor
        - hris_direct_employee
        - direct_employee
        - contractor_outside_deel
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings:
      type: object
      properties:
        access:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess
          description: Access settings for the custom field
        required:
          type: boolean
          description: Whether the custom field is required
        countries:
          type: array
          items:
            type: string
          description: Countries for which the custom field is applicable.
        is_enabled:
          type: boolean
          description: Whether the custom field is enabled
        worker_types:
          type: array
          items:
            $ref: >-
              #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems
          description: Worker types for which the custom field is applicable
      required:
        - access
        - required
        - is_enabled
      description: Settings for the custom field
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement:
      type: string
      enum:
        - profile
        - contract
      description: Valid placements for custom field
      title: >-
        PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement
    PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier of the custom field
        name:
          type: string
          description: Name of the custom field
        type:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType
          description: Type of the custom field
        settings:
          $ref: >-
            #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings
          description: Settings for the custom field
        placement:
          oneOf:
            - $ref: >-
                #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement
            - type: 'null'
          description: Valid placements for custom field
        created_at:
          type: string
          format: date-time
          description: Creation date of the custom field
        description:
          type:
            - string
            - 'null'
          description: Description of the custom field
      title: PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems
    custom-fields-people_getCustomFields_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/PeopleCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems
      required:
        - data
      title: custom-fields-people_getCustomFields_Response_200
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    ListAllPeopleCustomFieldsRequestInternalServerError:
      type: object
      properties:
        message:
          type: string
          description: Error message
      title: ListAllPeopleCustomFieldsRequestInternalServerError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/people/custom_fields"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/people/custom_fields';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/people/custom_fields"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/people/custom_fields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/people/custom_fields")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/people/custom_fields', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/people/custom_fields");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/people/custom_fields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```